;------------------------------------------------------------------------------
; AHA1030 BIOS RAM for i486 machine V2.2  Copyright(C) 2023 DOSsoft(܂)
;------------------------------------------------------------------------------
SHADOW_RAM_SEG  equ  0E800h
.186
IDE_equip       equ     10h     ; IDE BIOS bit
SASI_equip      equ     40h     ;SASI BIOS bit
SND_equip       equ     80h     ; SND BIOS bit
TEMP_ADDR       equ     5C00h
; 0000:0̃ItZbg       IRQ3 002Eh IRQ5 0036h
; ]}N di=si=ax=0̏ACXɃoCgݒ
PrepMemMove     macro   MEM_BYTE:REQ
                cld
                mov     cx,MEM_BYTE/2
                xor     ax,ax
                mov     di,ax
                mov     si,ax
endm

; rbgtOϐbit`
F_HIRESO        = 01h   ; 1high reso[h, 0normal[h
F_H98           = 02h   ; 1H98, 0PC-9801/21
F_PCI           = 04h   ; 1PCI@iPCI BIOSłȂn[hEFAŃ`FbNj
F_PCI2          = 08h   ; gp
F_RADA          = 10h   ; 19801RA-BX@
F_RETRO         = 20h   ; 1Ńg@i01,E/F/Mj
F_EPSON         = 40h   ; 1EPSON ID or EPSON 286@ gp

flagset         equ     byte ptr [bp-02h] ; }Vʁ^[h̃rbgtO
BuiltInDev      equ     byte ptr [bp-03h] ; 043Fhl C0,C2,C4,C6̂ꂩ
equip           equ     byte ptr [bp-04h] ; 053Dhl 
MemWindowAddr   equ     byte ptr [bp-05h] ; 08-09 BANK window address in EXROM
MemWindowNative equ     byte ptr [bp-06h] ; 08-09 BANK window native address 
FlagInDOS       equ     byte ptr [bp-07h]
CPUIDhigh       equ     byte ptr [bp-08h]
MachineID       equ     byte ptr [bp-09h] ; Machine ID
MachineType     equ     byte ptr [bp-0Ah] ; PCIp
ROW             equ     word ptr [bp-0Ch] ; \s
COLUMN          equ     word ptr [bp-0Eh] ; \J
SegTVRAM        equ     word ptr [bp-10h] ; T-VRAM̃ZOgA000/E000
MemBankIOAddr   equ     word ptr [bp-12h] ; (N)0461h / (H)0091h
SegPhysIDEBIOS  equ     word ptr [bp-14h] ; IDE BIOSZOgiIj
SegMMapIDEBIOS  equ     word ptr [bp-16h] ; IDE BIOSZOgiRAMmappingj
SegPhysSCSIBIOS equ     word ptr [bp-18h] ;SCSI BIOSZOgiIj
SegDiff         equ     word ptr [bp-1Ah]
SegTempMem      equ     word ptr [bp-1Ch] ; IPLwarêƂ5C00h
SegShadowRAM    equ     word ptr [bp-1Eh]
irq356_vect     equ     word ptr [bp-20h]

code            segment public use16
                assume cs:code,ds:code,es:code,ss:code
                org 100h  ; for MS-DOS .COM file
start:          jmp     begin
;--------------------------------------------------------
ttl_1           DB 0E5h," AHA-1030B/P,PC-9801-100BIOSRAM",0
ttl_2           DB 0A5h," A1030RAM ",0
ttl_3           DB 0E5h," Version 2.2 (C)2023 ܂ ",13,10,0
align 2
IRQ_table       DW  3, 002Eh,0036h,003Ah
OrgSegString    DW  offset orgCC00,orgD000,offset orgD400,offset orgD800,offset orgDC00
orgCC00         DB  0C1h,"  CC00",0
orgD000         DB  081h,"  D000",0
orgD400         DB  061h,"  D400",0
orgD800         DB  021h,"  D800",0
orgDC00         DB  0A1h,"  DC00",0
wrong_machine   DB  041h,"  ̋@ł͎gpł܂.",13,10,0
wrong_CPU       DB  041h,"  CPUł͎gpł܂.",13,10,0
H98_msg         DB  041h,"  PC-H98ł͎gpł܂.",13,10,0
Hires_msg       DB  0E1h,"  nC][V[hł͎gpł܂.",13,10,0
NoEPSON         DB  041h,"  EPSON 386/486@ł͎gpł܂.",13,10,0
PCI_machine     DB  0E1h,"  PCIoX ø@ł͓AhXRAM܂.",13,10,0
OK_msg1         DB  0E1h,"  SCSI BIOS",0 
OK_msgE800      DB  0E1h," E800:0Ɉړ܂. N88-BASIC ͎gȂȂ܂.               ",13,10,0
OK_msgCC00      DB  0E1h," CC00:0Ɉړ܂. Sound BIOS ͎gȂȂ܂.              ",13,10,0
E10exist_msg    DB  0C1h,"   SCSI(E10){[ho܂.   ~܂.                          ",13,10,0
absent_msg      DB  0C1h,"  AHA-1030/PC-9801-100 BIOS͌o܂ł.                           ",13,10,0
irq3_msg        DB  061h,"  IRQ   E800:0  shadow RAMɈړĂ悤ł.   ~܂.",13,10,0
;Stayed_CC00     DB  041h,"   CC00:0  shadow RAMɈړĂ悤ł.   ~܂.     ",13,10,0
;Stayed_E800     DB  041h,"   E800:0  shadow RAMɈړĂ悤ł.   ~܂.     ",13,10,0
;--------------------------------------------------------
begin:
                enter   28h,0
                xor     ax,ax
                mov     flagset,al
                mov     equip,al
                mov     BuiltInDev,al
                mov     MachineType,al
                mov     CPUIDhigh,al
                mov     FlagInDOS,al
                mov     COLUMN,ax
                mov     irq356_vect,ax
                mov     SegDiff,04000h
                mov     ROW,11

                call    SetSegTempMem
                call    ResoModeCheck   ; H98,nC]`FbN
                call    InDOS
                call    DisplayTitle

                test    flagset,F_H98   ; H98O
                mov     dx,offset H98_msg
                jnz     CancelPatch

                test    flagset,F_HIRESO ; nC]O
                mov     dx,offset Hires_msg
                jnz     CancelPatch

                call    CPU386check     ; 286ȉO
                mov     dx,offset wrong_CPU
                jc      CancelPatch

                mov     dx,offset NoEPSON
                call    CheckEPSONPC    
                jc      CancelPatch
                call    ScanA1030BIOS  ; AHA-1030BIOS
                mov     dx,offset absent_msg ; CC00-->D000-->D400-->D800-->DC00
                jc      CancelPatch     ; ȂΏI
                mov     si,offset OrgSegString
                mov     dx,[bx+si]
                call      _puts
                call    PCI_Check ; n[hEFA PCI}VO
                jc      Legacy486Machine
                call    GetCPUID

                mov     dx,offset wrong_machine

                cmp     MachineType,CHIP_450KX
                je      CancelPatch     ; StȂI

                call    MEMtoRAM_PCI    ; (typepci.s)
                cmp     CPUIDhigh,6
                jb      @f
                call    P6MSR
                jmp     CacheOK
        @@:
                test    MachineType,CHIP_VLSI
                jz      @f
                call    CacheVLSI
                jmp     CacheOK
        @@:
                test    MachineType,CHIP_Intel
                jz      @f
                call    CacheIntel
;               jmp     CacheOK
        @@:
CacheOK:        
                mov     dx,offset PCI_machine   ; OK
                jmp     CancelPatch
;------------------------------------
Legacy486Machine:
                call    CheckMate;      ; A-mateE10/FA02ڋ@O
                jc      NoE10board
                in      al,0F0h
                and     al,01000000b    ; 40h
                jnz     NoE10board
                ; E10 exist
                mov     dx,offset E10exist_msg
                call    _puts
                jMP     CancelPatch
NoE10board: ; ܂ŗΑ݂Ă
                call    Check3BIOS      ; ̓BIOS@\
                call    CheckIRQ3       ; AHA-1030gĂIRQ邩
                mov     dx,offset irq3_msg
                jc      CancelPatch     ; ȂCC00ɂȂĂΏI
                call    CopyROMtemp1    ; CփRs[

                call    ROMRAM          ; ROMRAMɂ
                mov     dx,offset PCI_machine
                jc      CancelPatch     ; ȂCC00ɂȂĂΏI
                pushf
                cli     ; 犄֎~
                call    CopyMEMRAM      ; C痠RAM֓]
                test    flagset,F_RADA
                jz      @f
                cmp     SegShadowRAM,0E800h
                jne     @f
                call    AdjustSumE8
        @@:     
                call    RAMROM_486      ; 80000oNƂɖ߂
                popf    ; 荞݋֎~Ԃ܂
                call    EnableParityError       ; NMIJn
                mov     dx,offset wrong_machine
                call    Equ_CC00_DC00   ; Rs[Ă邩v
                jnz     CancelPatch     ; svȂ@\zÕ}V
                call    Change_SysWork_Vect     ; [NGȀC
                mov     dx,offset OK_msg1       ; OK
                call    _puts
                mov     dx,offset OK_msgE800 ; OK
                cmp     SegShadowRAM,0E800h
                je      CancelPatch
                mov     dx,offset OK_msgCC00 ; OK
CancelPatch:    call    _puts
                test    flagset,F_PCI
                jnz     EndJob
                call    FlipSoundBIOS
                call    SaveFlags               ; tO㏑ۑ
EndJob:
                call    shiftkey_check
                leave
                RET
;               ŏI
;--------------------------------------------------------------
;       DisplayTitle    
;--------------------------------------------------------------
DisplayTitle    PROC   near
                pushf
                mov     dx,offset ttl_1
                call    _puts
                mov     bx,offset ttl_2
                test    FlagInDOS,1
                jz      @f
                mov     byte ptr [bx],0E5h
        @@:     mov     dx,bx
                call    _puts
                mov     dx,offset ttl_3
                call    _puts
                popf
                ret
DisplayTitle    ENDP

;--------------------------------------------------------------
;       ResoModeCheck   ( \JnOɂPxĂԂ )
;--------------------------------------------------2019/7/8----
ResoModeCheck   PROC    near
                xor     ax,ax
                push    ds
                mov     ds,ax
                mov     ah,ds:[0458h]   ; H98 check
                mov     al,ds:[0501h]   ; hi-reso check
                pop     ds

                test    ah,80h
                jz      @f
                or      flagset,F_H98
        @@:     
                mov     bx,0A000h
                mov     dx,0461h                ; EBhE|[g
                mov     MemWindowAddr,0Ch       ; EBhEmapping
                mov     MemWindowNative,08h     ; 8bank
                mov     SegShadowRAM,SHADOW_RAM_SEG

                test    al,8
                jz      @f
                or      flagset,F_HIRESO
                mov     bx,0E000h
                mov     dx,0091h                ; nC]̃EBhE|[g
                mov     MemWindowAddr,0Eh       ; EBhEmapping
                mov     MemWindowNative,10h     ; HIMEM.SYS삵ĂȂƂO
                mov     SegShadowRAM,0EA00h     
        @@:
                mov     SegTVRAM,bx             ; eLXgVRAM̃ZOgm肷
                mov     MemBankIOAddr,dx        ; EBhE|[g
                ret
ResoModeCheck   ENDP

;-------------------------------------------------------
;       CPU386check
;-------------------------------------------------------
CPU386check     PROC   near
                pushf
                pop     ax
                pushf
                or      ax,4000h
                push    ax
                popf
                pushf
                pop     ax
                popf
                and     ax,0C000h
                cmp     ax,4000h        
                jNe     Not386
                clc
                ret
Not386:         stc
                ret
CPU386check     ENDP


;--------------------------------------------------------
;       ROMRAM          
;--------------------------------------------------------
ROMRAM          PROC   near
                cmp     SegShadowRAM,0CC00h
                jne     @f
                or      equip,80h       ; TEhBIOS RAMotO𗧂Ă
        @@:
                cmp     SegShadowRAM,0A000h
                jb      InMainMem   ; A0Ȃ烁CłƂ
                cmp     SegShadowRAM,0E000h
                jb      @f          ; ȏ E0Ȃ EBhEE0
                mov     MemWindowAddr,0Eh       
                mov     SegDiff,06000h  ; AhXl4000->6000h
        @@:     call    DisableParityError  ; peBG[N肤̂NMI֎~
                call    ROMRAM486  ; 08oN0C0E𓊉eJn
InMainMem:      
                clc
                ret
ROMRAM          ENDP

;----------------------------------------------------------------------------
;       CopyROMtemp1  I/O 053Dh C-bus SCSIROMoĂԂɂĂ痈
;----------------------------------------------------------------------------
CopyROMtemp1    PROC   near ; UCɃRs[
                push    es      
                push    ds
                mov     ds,SegPhysSCSIBIOS      ; DC00AhX
                mov     es,SegTempMem;          ; 5C00C
                PrepMemMove     4000h
          rep   movsw   ; Rs[ 16KB
                pop     ds
                pop     es
                ret
CopyROMtemp1    ENDP

;------------------------------------------------------------------
;       CopyMEMRAM      C̓eVhERAMփRs[
;------------------------------------------------------------------
CopyMEMRAM      PROC   near
                test    flagset,F_PCI
                jnz     CopyMEM_PCI
if 0 ; ʂ̏ōsĂ̂łł͕sv
                mov     al,08h  ; peBG[N肤̂ŉ
                out     37h,al  ; Parity check disable 
                jmp     $+2
                jmp     $+2
                out     50h,al  ; NMI disable
                jmp     $+2
                jmp     $+2
endif
                push    ds
                mov     ds,SegTempMem           ; 5C00C
                mov     ax,SegShadowRAM         ; E800VhERAM
                cmp     ax,0A000h
                jb      @f
                sub     ax,SegDiff     ;4000h                ; CC00-4000h
         @@:    mov     es,ax                   ; 8C00VhERAM
                
                PrepMemMove     4000h
          rep   movsw   ; A8KBł邱Ƃɒ
                pop     ds
if 0
                mov     al,09h  ;
                out     52h,al  ; NMI enable
                jmp     $+2
                jmp     $+2
                out     37h,al  ; Parity check enable
                jmp     $+2
                jmp     $+2
endif
                clc
                ret
CopyMEM_PCI:    
                push    ds
                mov     ds,SegTempMem   ; 5C00C
                mov     es,SegShadowRAM ; VhERAMiAhXj
                PrepMemMove     4000h
          rep   movsw   ;    
                pop     ds
                stc
                ret
CopyMEMRAM      ENDP

.386
;-----------------------------------------------------------
;       ScanA1030BIOS   100{[hBIOST return BX
;-----------------------------------------------------------
ScanA1030BIOS   PROC   near
                mov     SegPhysSCSIBIOS,0CC00h  ; JñZOg
EntryA1030BIOS: 
                mov     es,SegPhysSCSIBIOS
                mov     ax,es:[0009h]   ; ? C-BUS ROM
                cmp     ax,0AA55h       ; C-BUS ROM signature (SCSI)
                jnz     SCSIBIOS_absent
                mov     eax,es:[0030h]
                cmp     eax,504E5024h   ; ? $PNP
                jnz     SCSIBIOS_absent
                mov     eax,es:[0058h]
                cmp     eax,0043454Eh   ; ? "NEC\0"
                jnz     SCSIBIOS_absent
ExistA1030BIOS: mov     ax,SegPhysSCSIBIOS ; CC00`DC00
                mov     cl,8    ; 8 bit shift
                shr     ax,cl   ; CC,D0,D4,D8,DC
                sub     al,0CCh ; 00,04,08,0C,10h
                shr     ax,1    ; 00, 2, 4, 6, 8
                mov     bx,ax   ; CC00̕ψ(even)
                clc
                ret
SCSIBIOS_absent:
                add     SegPhysSCSIBIOS,0400h   ; ʂ牺ʂɒT
                cmp     SegPhysSCSIBIOS,0E000h  ; D0͒TȂ
                jae     NoA1030BIOS
                jmp     EntryA1030BIOS
NoA1030BIOS:    stc
                ret
ScanA1030BIOS  ENDP

;---------------------------------------------------------------------------
include typepci.s       ; PCI֌W͕ʃt@C
;---------------------------------------------------------------------------
;--------------------------------------------------------
;       RAMROM_486
;--------------------------------------------------------
RAMROM_486      PROC    near
                mov     dx,MemBankIOAddr 
                mov     al,MemWindowNative      
                out     dx,al           ; 8-9 bank selected address 8000h

                mov     dx,053Dh ; 053D_mem_enabler_switch
                mov     al,06h   ; RAM window disable=1, BIOS RAM select=1
                or      al,equip
                out     dx,al
if 0
                mov     dx,043Fh ; SCSI_RAME10PATł͕Kv
                mov     al,BuiltInDev
;;;;;;;;;;;;;   or      al,0C4h  ; {vOł͎gpȂ
                out     dx,al
                mov     BuiltInDev,al
endif
                mov     dx,043Fh ; 
                mov     al,0A0h  ; clear cache 
                out     dx,al
                ret
RAMROM_486      ENDP


;------------------------------------------------------------------
;       peBG[֘A
;------------------------------------------------------------------
ChangeNMI       PROC   near
                add     al,8
                out     37h,al  ; Parity check disable 
                jmp     $+2
                jmp     $+2
                out     50h,al  ; NMI disable
                jmp     $+2
                jmp     $+2
                ret
ChangeNMI       ENDP
DisableParityError      PROC   near
                mov     al,0
                call    ChangeNMI
                ret
DisableParityError      ENDP
EnableParityError       PROC   near
                mov     al,1
                call    ChangeNMI
                ret
EnableParityError       ENDP


;--------------------------------------------------------
;       ROMRAM486
;--------------------------------------------------------
ROMRAM486       PROC    near
                mov     dx,043Fh ; 
                mov     al,0A0h   ; clear CPU cache 
                out     dx,al

                mov     dx,MemBankIOAddr ; 8-9 bank selected address C000
                mov     al,MemWindowAddr
                out     dx,al
                
                mov     dx,053Dh ; 053D_mem_enabler_switch
                mov     al,02h   ; BIOS RAM window access enable 
                or      al,equip
                out     dx,al
                ret
ROMRAM486       ENDP


;--------------------------------------------------------------------------
;       IsBuiltInBIOS   SOUND BIOS{̓̂ǂ`FbN es=CC00
;-----------------------------------------2022/9/24------------------------
IsBuiltInBIOS   PROC   near
                push    es
                push    ds
                mov     ax,es
                mov     ds,ax
                mov     es,SegTempMem
                PrepMemMove     4000h
        rep     movsw
                pop     ds
                pop     es

                mov     dx,053Dh
                mov     al,equip        ; 92
                or      al,10000010b
                out     dx,al           ; ݒs
                
                PrepMemMove     4000h
                mov     eax,es:[di]

                mov     dx,0461h
                mov     al,0Ch
                out     dx,al

                push    es
                push    ds
                mov     ax,8C00h
                mov     es,ax
                mov     ds,SegTempMem
                mov     cx,1000h/2
        rep     cmpsw
                pop     ds
                pop     es

                mov     dx,0461h
                mov     al,08h
                out     dx,al

                or      cx,cx
                jnz     NoBuiltInBIOS   ; BIOSƂ 
                mov     al,10000010b    
                or      equip,al
                clc                     ; BIOSƂNC
                ret
NoBuiltInBIOS:  mov     al,equip        ;
                and     al,01111111b    ; BIOŜ͖őbitւ܂
                mov     equip,al        ; tOɂݒԂ
                out     dx,al           ; ݒs
                stc                     ; BIOSƂCY
                ret
IsBuiltInBIOS   ENDP
.186

;---------------------------------------------------------------------
;       Get IDE BIOS segment address   ES:shadowed RAM   DX:real ROM
;---------------------------------------------------------------------1.10
GetSegIDEBIOS   PROC   near
                mov     ax,09800h   ; IDE BIOS address of memory window 
                mov     dx,0D800h   ; IDE BIOS address (physical)
                test    flagset,F_HIRESO        ; Normal mode
                jz      @f  ; Hiresolution mode
                mov     ax,08600h   ; IDE BIOS address of memory window 
                mov     dx,0E600h   ; IDE BIOS address (physical)
        @@:     
                mov     SegPhysIDEBIOS,dx
                mov     SegMMapIDEBIOS,ax
                ret
GetSegIDEBIOS   ENDP

if 0    ; nC]SCSI BIOS̃ZOg𓾂KvȂȂ̂łł͕sgp
;---------------------------------------------------------------------
;       Get SCSI BIOS segment address   ES:shadowed RAM   DX:real ROM
;---------------------------------------------------------------------1.10
GetSegSCSIBIOS  PROC    near
                mov     ax,08C00h   ; SCSI BIOS address of memory window 
                mov     dx,0DC00h   ; SCSI BIOS address (physical)
                test    flagset,F_HIRESO        ; Normal mode
                jz      @f          ; Hiresolution mode
                mov     ax,08E00h   ; SCSI BIOS address of memory window 
                mov     dx,0EE00h   ; SCSI BIOS address (physical)
        @@:     
                mov     SegPhysSCSIBIOS,dx
                mov     SegMMapSCSIBIOS,ax
                ret
GetSegSCSIBIOS  ENDP
endif

;---------------------------------------------------------------------
;       GetMachineID    input es<==ax,    output al (machine ID)
;---------------------------------------------------------------------
GetMachineID    PROC   near
                mov     es,ax
                mov     ax,es:[0]
                cmp     ax,2198h
                je      @f      ; 2198@̏ꍇׂ
                mov     al,1    ; machine ID1ɂ
                or      flagset,F_RADA  ; BA/BA̋@tO𗧂Ă
                stc
                ret
        @@:     mov     bx,003Fh
                mov     al,es:[bx]
                cmp     al,1    ; ROMAvBX/BAmachine ID1ɂ
                jne     @f      ; ꍇ BX/BAȉƂ
                or      flagset,F_RADA
        @@:     
                clc
                ret
GetMachineID    ENDP


;---------------------------------------------------------------------
;       CheckMate       
;---------------------------------------------------------------------
CheckMate       PROC   near
                test    flagset,F_HIRESO
                jz      MachineN
                jmp     MachineH
MachineH:       mov     ax,0FFE8h
                call    GetMachineID
                cmp     al,04h          ; Fixed on SCSI_RAM V2.23
                jae     NotAmate
                clc
                ret
MachineN:       mov     ax,0F8E8h
                call    GetMachineID
                or      al,al
                jz      a_mate1
                cmp     al,05h  ; Af
                jz      a_mate2
                cmp     al,06h  ; Aps/As2
                jz      a_mate2
                cmp     al,0Dh  ; An
                jz      a_mate2
                cmp     al,18h  ; Ap3/As3
                jz      a_mate2
                cmp     al, 02h ; PC-9821 Ce (with SCSI CD-ROM drive)
                je      C_multi1
NotAmate:       stc
                ret
fellow_FA:      ; ???
C_multi1:
a_mate1:
a_mate2:        clc
                ret
CheckMate       ENDP

;--------------------------------------------------------
;       SaveFlags       
;-------------------------------2022/9/24----------------
SaveFlags       PROC   near
                test    flagset,F_H98
                jz      @f
                ret
       @@:      push    ds
                push    ax
                xor     ax,ax
                mov     ds,ax
                mov     al,equip
                or      al,2
;;              or      ds:[05A7h],al
                mov     ds:[05A7h],al
                mov     al,BuiltInDev
;;              or      ds:[05B6h],al
                mov     ds:[05B6h],al
                pop     ax
                pop     ds
                ret
SaveFlags       ENDP


;---------------------------------------------------------------------------
SetSegTempMem   PROC   near
                test    FlagInDOS,1
                jnz     @f
                mov     SegTempMem,TEMP_ADDR
                ret
        @@:     
                mov     dx,cs
                mov     ax,offset DataSegment
                add     ax,16
                shr     ax,4
                add     dx,ax
                mov     SegTempMem,dx
                ret
SetSegTempMem   ENDP

;------------------------------------------------------------------
;         shiftkey_check  VtgL[`FbN҂ I
;------------------------------------------------------------------
shiftkey_check  PROC    near
                mov     cx,0EFF0h
WaitEnt:        out     5fh,al
                out     5fh,al
                out     5fh,al
                out     5fh,al
                out     5fh,al
                out     5fh,al
               loop     WaitEnt
ShiftKeyWait:   mov     ah,02h
                int 18h
                test    al,1    ; (bit 0) 1= bit mask of keyboard shift sens
                jnz     ShiftKeyWait
                ret
shiftkey_check  ENDP

include  putstrcs.inc   ; \[`͕t܂


.386
;-----------------------------------------------------------
;       Check3BIOS ( equiped peripherals and its BIOS ) 
;-------------------------------------------2022/9/24-------
Check3BIOS      PROC    near
                push    ds
                call    GetSegIDEBIOS
                mov     ds,dx
                mov     eax,ds:[0008h]   ; ? C-BUS ROM
                pop     ds
                cmp     eax,2AAA5590h    ; C-BUS ROM signature
                jnz     NoIDEBIOS
                or      equip,IDE_equip
                or      BuiltInDev,0C2h
NoIDE_ent:
                test    flagset,F_HIRESO
                jnz     EndCheckBIOS    ; ȉ̓nC]֌W
; SASI BIOS̏u
                mov     ax,0D700h       ; direct method D700 ROM
                push    ds
                mov     ds,ax
                mov     eax,ds:[0]
                pop     ds
                or      eax,eax         ; LROMf[^͖iRAM?j
                jz      @f
                cmp     eax,0FFFFFFFFh  ; LROMf[^͖
                je      @f
                or      equip,SASI_equip  ; SASI BIOS RAM݂̂Ƃ
                or      BuiltInDev,0C2h   ; SASI BIOS RAMłƂ
        @@:     nop
                nop
; TEhBIOS̏u
                mov     ax,0CC00h
                mov     es,ax
                mov     eax,es:[0]
                or      eax,eax
                jz      No_SNDBIOS
                cmp     eax,0FFFFFFFFh  ; ROM not exist
                je      No_SNDBIOS
                cmp     ax,0FFFFh       ; ROM not exist
                je      No_SNDBIOS
                or      eax,eax         ; ROM not exist
                jz      No_SNDBIOS
                call    IsBuiltInBIOS  ; f[^̂łɃ`FbN
                jc      No_SNDBIOS
                or      equip, SND_equip 
                jmp     EndCheckBIOS
No_SNDBIOS:     and     equip,01111111b ; BIOS͂Ȃ̂ő݃tO߂
EndCheckBIOS:   
                clc
                ret
BIOS_absent:
                stc
                ret
NoIDEBIOS:      ;;;;;;;mov     SegShadowRAM,0D800h
                and     equip,11101111b 
                jmp     NoIDE_ent
Check3BIOS      ENDP

;-----------------------------------------------------------
;       CheckEPSONPC
;-----------------------------------------------------------
CheckEPSONPC    PROC   near
                xor     ax,ax
                mov     es,ax
                mov     ax,0FD80h       ; seg
                mov     bx,0002h        ; ofs
                mov     cx,2A27h        ; EPSON 27h,2Ah (Normal)
                test    byte ptr es:[0501h],8
                jz      EpsonNormalMode
                mov     ax,0F800h       ; seg
                mov     bx,07F70h       ; ofs
                mov     cx,1827h        ; EPSON 27h,18h (Hireso)
EpsonNormalMode:  
                mov     es,ax
                cmp     es:[bx],cx      ; compare
                je      IsEPSONPC
                clc
                ret
IsEPSONPC:      
                mov     al,es:[3]
                mov     ah,0
                or      flagset,F_EPSON
                stc     ; CY=EPSON PC
                ret
CheckEPSONPC    ENDP

;--------------------------------------------------------------------
;       FlipSoundBIOS   CC00E800Ɉړ̂ƂSND BIOS
;--------------------------------------------------------------------
FlipSoundBIOS   PROC   near
                cmp     SegPhysSCSIBIOS,0CC00h
                jne     @f
                cmp     SegShadowRAM,0E800h
                jne     @f
                and     equip,01111111b
                mov     dx,053Dh
                mov     al,equip
                or      al,2
                out     dx,al
                stc
                ret
        @@:     clc
                ret
FlipSoundBIOS   ENDP

;--------------------------------------------------------------
;       GetCPUID
;--------------------------------------------------------------
GetCPUID        PROC   near
                push    es
                xor     ax,ax
                mov     es,ax
                mov     ax,es:[0486h]
                pop     es
                and     ax,0FFFh
                cmp     ax,0430h
                jae     @f
                xor     eax,eax
                inc     al
                cpuid
        @@:     xchg    al,ah
                mov     CPUIDhigh,al
                ret
GetCPUID        ENDP


;---------------------------------------------
;       Equ_CC00_DC00   
;---------------------------------------------
Equ_CC00_DC00   PROC   near
                PrepMemMove     4000h
                push    ds
                mov     ax,SegPhysSCSIBIOS
                mov     ds,ax
                mov     ax,SegShadowRAM
                mov     es,ax
        rep     cmpsw
                pop     ds
                or      cx,cx
                ret
Equ_CC00_DC00   ENDP

;---------------------------------------------
;       Change_SysWork_Vect
;---------------------------------------------
Change_SysWork_Vect     PROC   near
                xor     ax,ax
                mov     es,ax
                mov     ax,SegShadowRAM
                mov     bx,04B0h
                mov     di,irq356_vect
                pushf
                cli
                mov     es:[di],ax
                xchg    al,ah
                mov     es:[bx+02h],al
                mov     es:[bx+0Ah],al
                mov     es:[bx+0Ch],al
                popf
                ret
Change_SysWork_Vect     ENDP

;---------------------------------------------
;       CheckIRQ3
;---------------------------------------------
CheckIRQ3       PROC   near
                xor     ax,ax
                mov     es,ax
                mov     si,offset IRQ_table ; n[hxN^segꏊ
                lodsw   
                mov     cx,ax   ; rept 3
CheckIRQ3_ent:  
                lodsw
                mov     bx,ax
                mov     ax,es:[bx]
                cmp     ax,SegPhysSCSIBIOS
                jz      CheckIRQ3_OK
                cmp     ax,0E800h;     SHADOW_RAM_SEG     ;SegShadowRAM
                jz      CheckIRQ3_OK
               loop     CheckIRQ3_ent
CheckIRQ3_fail: 
                stc
                ret
CheckIRQ3_OK:   mov     irq356_vect,bx
                clc
                ret
CheckIRQ3       ENDP
;------------------------------------------
;       AdjustSumE8
;------------------------------------------
AdjustSumE8     PROC   near
                push    ds
                mov     dx,053Dh
                mov     al,0D2h
                out     dx,al
                
                mov     bx,07FFEh ; 0B1F0h
                mov     ax,(0E800h-6000h)
                mov     ds,ax
                mov     dx,0461h
                mov     al,0Eh
                out     dx,al
                
                mov     dx,0
                mov     si,dx
                mov     ds:[bx],dx
                mov     cx,4000h        ; 32KB
        @@:     lodsw
                add     dl,al
                add     dh,ah
               loop     @b
                neg     dl
                neg     dh
                mov     ds:[bx],dx

                mov     dx,0461h
                mov     al,08h
                out     dx,al
                
                pop     ds
                ret
AdjustSumE8     ENDP


;---------------------------------------------------
;       InDOS   DOSŎsIPLwaref
;---------------------------------------------------
InDOS           PROC   near
                xor     ax,ax
                mov     es,ax
                mov     ax,es:[0084h+2]   ; int 21h xN^`ȂDOS
                cmp     ax,0060h
                je      ExecDOS
                cmp     ax,0436h
                je      ExecDOS
                or      ax,ax
                jz      NotInDOS
                jmp     ExecDOS
NotInDOS:       clc
                ret     ; IPLwareƂ݂ďI
ExecDOS:        or      FlagInDOS,1
                mov     al,byte ptr es:[0710h]  ; =0060:110h
                mov     ah,0    ;    DOS䂵ĂJ[\sʒu
                cmp     al,1
                ja      @f
                mov     al,2
        @@:     dec     al
                dec     al
                mov     ROW,ax  ; ϐɃZbg
                stc
                ret     ; DOSƂ݂ďI
InDOS           ENDP

;================================================== DATA END =============
align   16
DataSegment     label word
DD      4 dup  (0)
code    ends
        end     start

