;----------------------------------------------------------------
;       PCI_Check       Ԓl CF
CHIP_NOPCI    EQU     80h   ; PCI chipset@ȊO 
CHIP_Intel    EQU     01h   ; 
CHIP_450KX    EQU     11h   ; inteltO
CHIP_CONF1    EQU     21h   ; Xa,Xt 
CHIP_Intel_P6 EQU     41h   ; 440FX
CHIP_RCC      EQU     02h   ; RvII26/RsII26̂ OK
CHIP_VLSI     EQU     04h   ; WaildCat          OK
CHIP_GGate    EQU     08h   ; ڃfXNgbv@͂邩s
;------------------------------------------------------------------------
;  C000,D000`̊gROM̈RAMoWriteۂ̐ݒ
;    ax=ZOgCbl=rbg 00b:PCI       11b:RAM R/W
;      (ah)                           01b:RAM R/O   10b:(RAM W/O)
;       TCY͕KSjoCgAESjoCg
;       2005-2-17    450KX 
;------------------------------------------------------------------------
EXROMRAM_SUB    PROC    near
                cmp     bl,1
                jz      BL_1_or_2
                cmp     bl,2
                jz      BL_1_or_2
                ret
BL_1_or_2:      inc     bl
                ret
EXROMRAM_SUB    ENDP

EXROMRAM        PROC    near
                xchg    al,ah           ; AL<--AH
                cmp     al,0C0h         
                jb      EXROMRAM_abort  
                cmp     al,0F0h
                jae     EXROMRAM_abort
                mov     ch,al
                mov     eax,80000000h
                mov     dx,0CF8h
                out     dx,eax
                mov     dl,0FCh
                in      ax,dx
                cmp     ax,8086h
                jz      IntelMC
                cmp     ch,0E0h
                jae     EXROMRAM_abort
                cmp     ax,1166h
                jz      RCC_MC
                cmp     ax,1004h
                jz      VLSI_MC
                cmp     ax,0FFFFh
                jne     EXROMRAM_abort
                mov     eax,8000A000h
                mov     dx,0CF8h
                out     dx,eax
                mov     dl,0FCh
                in      eax,dx
                cmp     eax,84C58086h   ; 450KX memory controller 
                jnz     EXROMRAM_abort  ; not found
; 450KX@(St20)   
                mov     eax,8000C800h
                mov     cl,ch
                sub     cl,0B0h
                mov     al,cl
                and     cl,00011111b
                shr     al,5
                shl     al,2
                add     al,58h
                mov     dx,0CF8h
                out     dx,eax
                mov     dl,0FCh
                in      eax,dx
                ror     eax,cl
                mov     bh,bl
                not     bl
                and     bl,03h
                and     al,0FCh
                or      al,bl
                xchg    bl,bh
                rol     eax,cl
                out     dx,eax
                mov     eax,8000A000h
                JMP     KX450end

VLSI_MC:        call    EXROMRAM_SUB
                xchg    al,ch
                mov     ah,0
                sub     al,0C0h
                shr     al,1
                add     al,16
                mov     cl,al
                mov     ch,0
                mov     al,64h  ; 64h=A0, 65h=B0, 66h=C0, 67h=D0, 11b=RAMW
                jmp     COMMON_MC

RCC_MC:         call    EXROMRAM_SUB
                xchg    al,ch
                mov     ah,0
                sub     al,0C0h
                shr     al,1
                add     al,8
                mov     cl,al
                mov     ch,0
                mov     al,70h
                jmp     COMMON_MC

IntelMC:        mov     ax,0
KX450end:       
                mov     cl,ch
                sub     cl,0B0h
                mov     AL,CL
                and     CL,00011111b
                shr     al,5
                shl     al,2
                add     al,58h          ; Intel PAM base

COMMON_MC:      mov     dx,0CF8h
                out     dx,eax
                mov     dl,0FCh
                in      eax,dx
                ror     eax,cl
                and     al,0FCh
                or      al,bl
                rol     eax,cl
                out     dx,eax
                clc
                ret
EXROMRAM_abort: stc
                ret
EXROMRAM        ENDP


;--------------------------------------------------------------
;       MEMtoRAM_PCI    
;--------------------------------------------------------------
MEMtoRAM_PCI    PROC    near
                push    es      
                push    ds
                mov     ds,SegPhysSCSIBIOS      ; DC00AhX
                mov     es,SegTempMem;          ; 5C00C
                PrepMemMove     4000h
          rep   movsw   ; Rs[ 16KB

                mov     ax,SegPhysSCSIBIOS
                mov     bx,3
                call    EXROMRAM
                
                pushf
                cli
                mov     ds,SegTempMem;          ; 5C00C
                mov     es,SegPhysSCSIBIOS      ; DC00AhX
                PrepMemMove     4000h
        rep     movsw
                popf

                pop     ds
                pop     es
                ret
MEMtoRAM_PCI    ENDP

;--------------------------------------------------------
;       PCI_Check ( by hardware )
;--------------------------------------------------------
PCI_Check       PROC    near
                mov     eax,80000000h   ; PCIWX^
                mov     MachineType,al  ; ϐ MachineType̓[ŏ

                mov     dx,0CF8h        ; `bvZbg WX^00
                out     dx,eax          ; 
                mov     dl,0FCh         ; 
                in      eax,dx          ; eaxœǂ
                cmp     eax,00051166h   ; x_R[h RCC/NEC chipset
                je      RCC_ChipSet     ; ȂRCC
                cmp     eax,00071004h   ; x_EfoCXVLSI_ChipSet:7
                je      VLSI_ChipSet    ; Ȃ炻 
                cmp     eax,00051004h   ; x_EfoCXVLSI_ChipSet:5
                je      VLSI_ChipSet    ; Ȃ炻 
                cmp     eax,12378086h   ; x_R[h Intel 440FX chipset
                je      IntelChipSetP6  ; Ȃintel(P6)
                cmp     ax,8086h        ; x_R[h Intel chipset
                je      IntelChipSet    ; Ȃintel

                mov     eax,8000C800h   ; Ô߃foCX25`FbN
                mov     dx,0CF8h
                out     dx,eax
                mov     dl,0FCh
                in      eax,dx
                cmp     eax,84C48086h   ; ̃x_EfoCXR[hȂ
                jz      KX450_Chipset   ; intel KX450( St20 )
                ; ǂɂYȂΏXa,Xt,XfΉ˂
PCI_Check_fail: ; Ή@̏ꍇAʏr[v܂
;                call    Beep
                stc
                ret
                
NoPCI_Chipset:  mov     MachineType,CHIP_NOPCI ; 486@
                jmp     NOPCI_machine

RCC_ChipSet:    mov     MachineType,CHIP_RCC
                jmp     PCI_Check_OK    ; 탊^[

IntelChipSetP6: mov     MachineType,CHIP_Intel_P6
                jmp     PCI_Check_OK    ; 탊^[

IntelChipSet:   mov     MachineType,CHIP_Intel
                jmp     PCI_Check_OK    ; 탊^[

VLSI_ChipSet:   mov     MachineType,CHIP_VLSI
                jmp     PCI_Check_OK    ; 탊^[  Ή0.40

KX450_Chipset:  mov     MachineType,CHIP_450KX
                jmp     PCI_Check_OK    ; NotΉ
PCI_Check_OK:   or      flagset,F_PCI
                clc
                ret
NOPCI_machine:  
                stc
                ret
PCI_Check       ENDP

;--------------------------------------------------------------
;       CacheIntel
;--------------------------------------------------------------
CacheIntel      PROC   near
                xor     ebx,ebx
                cmp     SegPhysSCSIBIOS,0D000h
                je      intel_D000
                cmp     SegPhysSCSIBIOS,0D400h
                je      intel_D400
                cmp     SegPhysSCSIBIOS,0DC00h
                je      intel_DC00
                cmp     SegPhysSCSIBIOS,0CC00h
                je      intel_CC00
                cmp     SegPhysSCSIBIOS,0E800h
                je      intel_E800
                ret

intel_CC00:     mov     ebx,0111000000000000b
                mov     eax,80000058h
                jmp     intel_5E
intel_D000:     mov     bl,00000111b
                jmp     intel_5C
intel_D400:     mov     bl,01110000b
                jmp     intel_5C
intel_DC00:     mov     bh,01110000b
                jmp     intel_5C
intel_E800:     mov     ebx,0111000000000000b
                jmp     intel_5C
intel_5C:       mov     eax,8000005Ch
intel_5E:       mov     dx,0CF8h
                out     dx,eax
                mov     dx,0CFCh
                in      eax,dx
                or      eax,ebx
                out     dx,eax
                ret
CacheIntel      ENDP
;--------------------------------------------------------------
;       CacheVLSI       
;--------------------------------------------------------------
CacheVLSI       PROC   near
                mov     bx,0
                cmp     SegPhysSCSIBIOS,0D000h
                je      VLSI_D000
                cmp     SegPhysSCSIBIOS,0D400h
                je      VLSI_D400
                cmp     SegPhysSCSIBIOS,0DC00h
                je      VLSI_DC00
                cmp     SegPhysSCSIBIOS,0CC00h
                je      VLSI_CC00
                cmp     SegPhysSCSIBIOS,0E800h
                je      VLSI_E800
                ret
                
VLSI_D000:      mov     bh,00000011b
                jmp     VLSI_6F
VLSI_D400:      mov     bh,00001100b
                jmp     VLSI_6F
VLSI_DC00:      mov     bh,11000000b
                jmp     VLSI_6F
VLSI_CC00:      mov     bl,11000000b
                jmp     VLSI_6F
VLSI_E800:      mov     bl,00110000b
                mov     eax,80000070h
                jmp     VLSI_70
VLSI_6F:        mov     eax,8000006Ch
VLSI_70:        mov     dx,0CF8h
                out     dx,eax
                mov     dx,0CFCh
                in      eax,dx
                rol     eax,16
                or      ax,bx
                ror     eax,16
                out     dx,eax
                ret
CacheVLSI       ENDP
;--------------------------------------------------------------
;       WrMSR   ecx=MSR edx,eax
;--------------------------------------------------------------
WriteMSR        PROC   near
                pushf   
                cli     
                wbinvd  
                wrmsr   
                popf    
                ret
WriteMSR        ENDP
;-----------------------------------------------

;--------------------------------------------------------------
;       P6MSR
;--------------------------------------------------------------
P6MSR           PROC   near
                cmp     SegPhysSCSIBIOS,0D000h
                je      MSR_D000
                cmp     SegPhysSCSIBIOS,0D400h
                je      MSR_D400
                cmp     SegPhysSCSIBIOS,0DC00h
                je      MSR_DC00
                cmp     SegPhysSCSIBIOS,0E800h
                je      MSR_E800
                cmp     SegPhysSCSIBIOS,0CC00h
                je      MSR_CC00
                jmp     End_WrMSR

MSR_D000:       mov     ECX,026Ah
                rdmsr
                mov     EAX,04040404h   ; D000-D3FF
                
                call    WriteMSR
                jmp     End_WrMSR
MSR_D400:       mov     ECX,026Ah
                rdmsr
                mov     EDX,04040404h   ; D400-D7FF
                call    WriteMSR
                jmp     End_WrMSR
MSR_DC00:       mov     ECX,026Bh
                rdmsr
                mov     EDX,04040404h   ; DC00-DFFF
                call    WriteMSR
                jmp     End_WrMSR
MSR_E800:       mov     ECX,026Dh       ; E8,EC
                rdmsr
                mov     EAX,04040404h   ; E800-EBFF
                call    WriteMSR
                jmp     End_WrMSR
MSR_CC00:       mov     ECX,0269h       ; C8,CC
                rdmsr
                mov     EDX,04040404h   ; CC00-DFFF
                call    WriteMSR
                jmp     End_WrMSR
End_WrMSR:
                ret
P6MSR           ENDP
